var NAVTREE =
[
  [ "CGAL 4.10 - Manual", "index.html", [
    [ "Getting Started", "general_intro.html", "general_intro" ],
    [ "Tutorials", "tutorials.html", "tutorials" ],
    [ "Package Overview", "packages.html", [
      [ "Arithmetic and Algebra", "packages.html#PartAlgebraicFoundations", [
        [ "Algebraic Foundations", "packages.html#PkgAlgebraicFoundationsSummary", null ],
        [ "Number Types", "packages.html#PkgNumberTypesSummary", null ],
        [ "Modular Arithmetic", "packages.html#PkgModularArithmeticSummary", null ],
        [ "Polynomial", "packages.html#PkgPolynomialSummary", null ],
        [ "Algebraic Kernel", "packages.html#PkgAlgebraicKerneldSummary", null ]
      ] ],
      [ "Combinatorial Algorithms", "packages.html#PartCombinatorialAlgorithms", [
        [ "Monotone and Sorted Matrix Search", "packages.html#PkgMatrixSearchSummary", null ],
        [ "Linear and Quadratic Programming Solver", "packages.html#PkgQPSolverSummary", null ]
      ] ],
      [ "Geometry Kernels", "packages.html#PartKernels", [
        [ "2D and 3D Linear Geometry Kernel", "packages.html#PkgKernel23Summary", null ],
        [ "dD Geometry Kernel", "packages.html#PkgKernelDSummary", null ],
        [ "2D Circular Geometry Kernel", "packages.html#PkgCircularKernel2Summary", null ],
        [ "3D Spherical Geometry Kernel", "packages.html#PkgSphericalKernel3Summary", null ]
      ] ],
      [ "Convex Hull Algorithms", "packages.html#PartConvexHullAlgorithms", [
        [ "2D Convex Hulls and Extreme Points", "packages.html#PkgConvexHull2Summary", null ],
        [ "3D Convex Hulls", "packages.html#PkgConvexHull3Summary", null ],
        [ "dD Convex Hulls and Delaunay Triangulations", "packages.html#PkgConvexHullDSummary", null ]
      ] ],
      [ "Polygons", "packages.html#PartPolygons", [
        [ "2D Polygons", "packages.html#PkgPolygon2Summary", null ],
        [ "2D Regularized Boolean Set-Operations", "packages.html#PkgBooleanSetOperations2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons", "packages.html#PkgNef2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons Embedded on the Sphere", "packages.html#PkgNefS2Summary", null ],
        [ "2D Polygon Partitioning", "packages.html#PkgPolygonPartitioning2Summary", null ],
        [ "2D Straight Skeleton and Polygon Offsetting", "packages.html#PkgStraightSkeleton2Summary", null ],
        [ "2D Minkowski Sums", "packages.html#PkgMinkowskiSum2Summary", null ],
        [ "2D Polyline Simplification", "packages.html#PkgPolylineSimplification2Summary", null ],
        [ "2D Visibility Computation", "packages.html#PkgVisibility_2Summary", null ]
      ] ],
      [ "Cell Complexes and Polyhedra", "packages.html#PartPolyhedra", [
        [ "3D Polyhedral Surface", "packages.html#PkgPolyhedronSummary", null ],
        [ "Halfedge Data Structures", "packages.html#PkgHDSSummary", null ],
        [ "Surface Mesh", "packages.html#PkgSurfaceMeshSummary", null ],
        [ "Combinatorial Maps", "packages.html#PkgCombinatorialMapsSummary", null ],
        [ "Generalized Maps", "packages.html#PkgGeneralizedMapsSummary", null ],
        [ "Linear Cell Complex", "packages.html#PkgLinearCellComplexSummary", null ],
        [ "3D Boolean Operations on Nef Polyhedra", "packages.html#PkgNef3Summary", null ],
        [ "Convex Decomposition of Polyhedra", "packages.html#PkgConvexDecomposition3Summary", null ],
        [ "3D Minkowski Sum of Polyhedra", "packages.html#PkgMinkowskiSum3Summary", null ]
      ] ],
      [ "Arrangements", "packages.html#PartArrangements", [
        [ "2D Arrangements", "packages.html#PkgArrangement2Summary", null ],
        [ "2D Intersection of Curves", "packages.html#PkgIntersectionOfCurves2Summary", null ],
        [ "2D Snap Rounding", "packages.html#PkgSnapRounding2Summary", null ],
        [ "2D Envelopes", "packages.html#PkgEnvelope2Summary", null ],
        [ "3D Envelopes", "packages.html#PkgEnvelope3Summary", null ]
      ] ],
      [ "Triangulations and Delaunay Triangulations", "packages.html#PartTriangulationsAndDelaunayTriangulations", [
        [ "2D Triangulation", "packages.html#PkgTriangulation2Summary", null ],
        [ "2D Triangulation Data Structure", "packages.html#PkgTDS2Summary", null ],
        [ "2D Periodic Triangulations", "packages.html#PkgPeriodic2Triangulation2Summary", null ],
        [ "3D Triangulations", "packages.html#PkgTriangulation3Summary", null ],
        [ "3D Triangulation Data Structure", "packages.html#PkgTDS3Summary", null ],
        [ "3D Periodic Triangulations", "packages.html#PkgPeriodic3Triangulation3Summary", null ],
        [ "dD Triangulations", "packages.html#PkgTriangulationsSummary", null ],
        [ "2D Alpha Shapes", "packages.html#PkgAlphaShape2Summary", null ],
        [ "3D Alpha Shapes", "packages.html#PkgAlphaShapes3Summary", null ]
      ] ],
      [ "Voronoi Diagrams", "packages.html#PartVoronoiDiagrams", [
        [ "2D Segment Delaunay Graphs", "packages.html#PkgSegmentDelaunayGraph2Summary", null ],
        [ "L Infinity Segment Delaunay Graphs", "packages.html#PkgSDGLinfSummary", null ],
        [ "2D Apollonius Graphs (Delaunay Graphs of Disks)", "packages.html#PkgApolloniusGraph2Summary", null ],
        [ "2D Voronoi Diagram Adaptor", "packages.html#PkgVoronoiDiagramAdaptor2Summary", null ]
      ] ],
      [ "Mesh Generation", "packages.html#PartMeshing", [
        [ "2D Conforming Triangulations and Meshes", "packages.html#PkgMesh2Summary", null ],
        [ "3D Surface Mesh Generation", "packages.html#PkgSurfaceMesher3Summary", null ],
        [ "3D Skin Surface Meshing", "packages.html#PkgSkinSurface3Summary", null ],
        [ "3D Mesh Generation", "packages.html#PkgMesh_3Summary", null ]
      ] ],
      [ "Shape Reconstruction", "packages.html#PartReconstruction", [
        [ "Poisson Surface Reconstruction", "packages.html#PkgPoissonSurfaceReconstructionSummary", null ],
        [ "Scale-Space Surface Reconstruction", "packages.html#PkgScaleSpaceReconstruction3Summary", null ],
        [ "Advancing Front Surface Reconstruction", "packages.html#PkgAdvancingFrontSurfaceReconstructionSummary", null ],
        [ "Optimal Transportation Curve Reconstruction", "packages.html#PkgOptimalTransportationReconstruction2Summary", null ]
      ] ],
      [ "Geometry Processing", "packages.html#PartGeometryProcessing", [
        [ "Polygon Mesh Processing", "packages.html#PkgPolygonMeshProcessingSummary", null ],
        [ "3D Surface Subdivision Methods", "packages.html#PkgSurfaceSubdivisionMethods3Summary", null ],
        [ "Triangulated Surface Mesh Segmentation", "packages.html#PkgSurfaceSegmentationSummary", null ],
        [ "Triangulated Surface Mesh Simplification", "packages.html#PkgSurfaceMeshSimplificationSummary", null ],
        [ "Triangulated Surface Mesh Deformation", "packages.html#PkgSurfaceMeshDeformationSummary", null ],
        [ "Triangulated Surface Mesh Parameterization", "packages.html#PkgSurfaceParameterizationSummary", null ],
        [ "Triangulated Surface Mesh Shortest Paths", "packages.html#PkgSurfaceMeshShortestPathSummary", null ],
        [ "Triangulated Surface Mesh Skeletonization", "packages.html#PkgMeanCurvatureSkeleton3Summary", null ],
        [ "Approximation of Ridges and Umbilics on Triangulated Surface Meshes", "packages.html#PkgRidges_3Summary", null ],
        [ "Estimation of Local Differential Properties of Point-Sampled Surfaces", "packages.html#PkgJet_fitting_3Summary", null ],
        [ "3D Point Set", "packages.html#PkgPointSet3Summary", null ],
        [ "Point Set Processing", "packages.html#PkgPointSetProcessingSummary", null ],
        [ "Point Set Shape Detection", "packages.html#PkgPointSetShapeDetection3Summary", null ],
        [ "2D Placement of Streamlines", "packages.html#PkgPlacementOfStreamlines2Summary", null ]
      ] ],
      [ "Spatial Searching and Sorting", "packages.html#PartSearchStructures", [
        [ "2D Range and Neighbor Search", "packages.html#PkgPointSet2Summary", null ],
        [ "Interval Skip List", "packages.html#PkgIntervalSkipListSummary", null ],
        [ "dD Spatial Searching", "packages.html#PkgSpatialSearchingDSummary", null ],
        [ "dD Range and Segment Trees", "packages.html#PkgRangeSegmentTreesDSummary", null ],
        [ "Intersecting Sequences of dD Iso-oriented Boxes", "packages.html#PkgBoxIntersectionDSummary", null ],
        [ "3D Fast Intersection and Distance Computation", "packages.html#PkgAABB_treeSummary", null ],
        [ "Spatial Sorting", "packages.html#PkgSpatialSortingSummary", null ]
      ] ],
      [ "Geometric Optimization", "packages.html#PartGeometricOptimization", [
        [ "Bounding Volumes", "packages.html#PkgBoundingVolumesSummary", null ],
        [ "Inscribed Areas", "packages.html#PkgInscribedAreasSummary", null ],
        [ "Optimal Distances", "packages.html#PkgOptimalDistancesSummary", null ],
        [ "Principal Component Analysis", "packages.html#PkgPrincipalComponentAnalysisDSummary", null ]
      ] ],
      [ "Interpolation", "packages.html#PartInterpolation", [
        [ "2D and Surface Function Interpolation", "packages.html#PkgInterpolation2Summary", null ],
        [ "2D Generalized Barycentric Coordinates", "packages.html#PkgBarycentric_coordinates_2Summary", null ]
      ] ],
      [ "Kinetic Data Structures", "packages.html#PartKineticDataStructures", [
        [ "Kinetic Data Structures", "packages.html#PkgKdsSummary", null ],
        [ "Kinetic Framework", "packages.html#PkgKdsFrameworkSummary", null ]
      ] ],
      [ "Support Library", "packages.html#PartSupportLibrary", [
        [ "STL Extensions for CGAL", "packages.html#PkgStlExtensionSummary", null ],
        [ "CGAL and the Boost Graph Library", "packages.html#PkgBGLSummary", null ],
        [ "CGAL and Solvers", "packages.html#PkgSolverSummary", null ],
        [ "CGAL and Boost Property Maps", "packages.html#PkgProperty_mapSummary", null ],
        [ "Cone-Based Spanners", "packages.html#PkgConeBasedSpannersSummary", null ],
        [ "Handles and Circulators", "packages.html#PkgHandlesAndCirculatorsSummary", null ],
        [ "Geometric Object Generators", "packages.html#PkgGeneratorsSummary", null ],
        [ "Profiling tools, Hash Map, Union-find, Modifiers", "packages.html#PkgProfilingToolsSummary", null ],
        [ "IO Streams", "packages.html#PkgIOstreamsSummary", null ]
      ] ],
      [ "Visualization", "packages.html#PartVisualization", [
        [ "Geomview", "packages.html#PkgGeomviewSummary", null ],
        [ "CGAL and the Qt Graphics View Framework", "packages.html#PkgGraphicsViewSummary", null ],
        [ "CGAL Ipelets", "packages.html#PkgCGALIpeletsSummary", null ]
      ] ]
    ] ],
    [ "Developer Manual", "dev_manual.html", "dev_manual" ],
    [ "Acknowledging CGAL", "how_to_cite_cgal.html", null ],
    [ "Bibliographic References", "citelist.html", null ],
    [ "Class and Concept List", "annotated.html", "annotated" ]
  ] ]
];

var NAVTREEINDEX =
[
".html",
"classAlgebraicKernel__d__1.html#ac477a67047349405e1d2f37681ccf6a1",
"classAlgebraicStructureTraits.html#a7bc6600f8722894f2434be8e3a6daf1e",
"classArrangementDcelFace.html#afbf2cc28a869d63904f688dabc1fe371",
"classBasicMatrix.html#a917632ba745c01fff83522c982a9e2f6",
"classCGAL_1_1Alpha__shape__2.html#a7c609024ff3d3ec5d862ca785c4717ac",
"classCGAL_1_1Approximate__min__ellipsoid__d__traits__2.html",
"classCGAL_1_1Arr__face__extended__text__formatter.html",
"classCGAL_1_1Arr__rational__function__traits__2_1_1Curve__2.html#a4119d8744955c862b1c2695975dc6caf",
"classCGAL_1_1CatmullClark__mask__3.html#a3a37af0ba48d045797276e52aeb5eea7",
"classCGAL_1_1Concurrent__compact__container.html#a25114761b690fd90ff584b2a88a0bc54",
"classCGAL_1_1Convex__hull__d.html#a9cf97c124cbf52bab38257eab95252e2",
"classCGAL_1_1Delaunay__triangulation.html#a6cb42daf0ab15bf36cb23a51e246e88d",
"classCGAL_1_1Envelope__diagram__2_1_1Vertex.html#a7d112578df64e169eb436652d5b52d69",
"classCGAL_1_1General__polygon__set__2.html#a9bca5d457fc8c8ac24bf920ebb946adc",
"classCGAL_1_1Gps__default__dcel.html",
"classCGAL_1_1In__place__list.html#a88ce4e790bd8395eb16d38876855600e",
"classCGAL_1_1Join__input__iterator__1.html#a6a35e3b77281079a7be6b9b4d5ece90b",
"classCGAL_1_1Linear__cell__complex.html",
"classCGAL_1_1Min__ellipse__2.html#a65b6136765ccef6366f308112075c45c",
"classCGAL_1_1Mpzf.html#abf44751a72a9d79806f39d87f02e2c6d",
"classCGAL_1_1Nef__polyhedron__3.html#afc9ae4754ea1d424b3e9a46a387d52f0",
"classCGAL_1_1Nef__polyhedron__S2_1_1Sphere__segment.html#a3843b38726d24a4d15eff7d738ca4c23",
"classCGAL_1_1Periodic__2__triangulation__2.html#a4d430d7a064cb69747d12bf457bb4e34a6665019f627d7eac50717c70129ed098",
"classCGAL_1_1Periodic__3__triangulation__3.html#a771009764e828ba7210d4874baafcea4",
"classCGAL_1_1Point__3.html#a718f29e670d70c3cbf346b386bcbe3a0",
"classCGAL_1_1Polygon__offset__builder__2.html",
"classCGAL_1_1Polyhedron__min__items__3.html#a83bbca2bb6db55b713cff99411de8cff",
"classCGAL_1_1Quadratic__program__options.html#aa5c09dc521f691e81ce97975386f2ec2",
"classCGAL_1_1Random__points__on__square__2.html",
"classCGAL_1_1Regular__triangulation__euclidean__traits__3.html#ad4886f2681ea75b53c635a5a6c922326",
"classCGAL_1_1Segment__Delaunay__graph__2.html#a67dff2495b4aa1cbceff834570fca4f6",
"classCGAL_1_1Sorted__matrix__search__traits__adaptor.html#a9c7b2285d97000874516fdae6b91ca66",
"classCGAL_1_1Surface__mesh.html#afc562714e2f4c824ed4c517801b642ea",
"classCGAL_1_1Triangulation.html#a43584d2efaa89634ca488662ebce6800",
"classCGAL_1_1Triangulation__3.html#a0b9612066a1232014236518a095b23b7",
"classCGAL_1_1Triangulation__3.html#a9457c1ddfc2249f20c362ee179fc8d7b",
"classCGAL_1_1Triangulation__data__structure__3.html#a3e17ffe7e3d4adc515013a020150caef",
"classCGAL_1_1Vector__2.html#aacc5925b8451b6b08b8390973dbd5d45",
"classCGAL_1_1Voronoi__intersection__2__traits__3.html#ae7d80109055ff689e3308588047bf9e7",
"classCircularKernel_1_1DoIntersect__2.html",
"classDelaunayLiftedTraits__d.html#a3811c23a85ea758c42190044a850abda",
"classEnvelopeDiagram__1.html#a3adc9e59de8759929a6d11f2b878e50d",
"classGenericMap.html#a1c2f23904f30576051341aaf67b5837d",
"classHalfedgeDSVertex.html#a2da715cebc6e03677ca6f16b23895bb3",
"classKernel.html#a7123f2f2056f2060a7f9fef226407236",
"classKernel_1_1ComparePowerDistance__3.html#a4c74dd7e4581caefd03e3f3efbce4988",
"classKernel_1_1ConstructCartesianConstIterator__3.html#a272a821591b93776511764c2ccce2e47",
"classKernel_1_1ConstructVector__2.html#a87acd718350d56f0347427ce1bf702a7",
"classKernel_1_1WeightedPoint__3.html",
"classLvaluePropertyMap.html",
"classMeshVertexBase__3.html#a6148b21c4599c439b85e16405a1f6ad8",
"classParameterizationMesh__3.html#a4d93ec00c3a9714fc68bf35f6c2eaf83",
"classPolygonTraits__2.html#a1ac1caf99c0576da161384472a0d9593",
"classPolynomialTraits__d_1_1Shift.html#ac23647c7f4f956c48da2682463d1fcd2",
"classRegularTriangulationVertexBase__3.html#ac78e0c25a1cde244edcf72a5242e7ea2",
"classSparseLinearAlgebraTraits__d.html#a6ee7d77b1b2a6ae27c53c2f3d569d554",
"classSphericalKernel_1_1MakeThetaMonotone__3.html#a6b2acbb39b0a9082b7ce94293c6e1657",
"classSurfaceMeshTriangulation__3.html#a88d765d63d13de7971cf0ac29907ca09",
"classTriangulationDataStructure_1_1FullCell.html#ab781e7d2cb602d3cf84e14b293619eec",
"classTriangulationDataStructure__3_1_1Cell.html#ae515e215b86b3638618748860ddc387b",
"devman_info.html",
"packages.html#PkgPrincipalComponentAnalysisDSummary"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

